#*************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: guidecamMisc.tcl,v 1.25.1.6 2005/12/09 18:38:44 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin  21/11/96  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#


#guidecam_block begin
proc guideProbeSettings {image win} {
    global gvar 

    if [winfo exists $win.guideProbeSettings] {
	utilRaiseWindow $win.guideProbeSettings
    } elseif {$gvar(lite)} {
	armDisplayDlgLite $win.guideProbeSettings -image $image
    } else {
	armDisplayDlg $win.guideProbeSettings -image $image
    }
}
#guidecam_block end

# This procedure is attached to a bind <Any-Enter> to specify
# the link between 'selected object in the image' and associated record 
# in the catalog
proc guidecamGetSelected { wdgTable } {
   global ::tcs

#   if {$tcs(starSelMode) == 1} {
#      guidecamGetStarParams  [split [$wdgTable get_selected] " "]
#   }
}

#This proc. record all relevant parameters of the selected star in the 
# tcs() array

proc guidecamGetStarParams { rec } {
   global tcs

#   puts "DBG> guidecamGetStarParams $rec"

   lassign $rec dummy tcs(ra) tcs(dec) coordSystem tcs(epoch)\
                      pma pmd radvel parallax cooType


#  puts "DBG> $dummy , $tcs(ra) ,  $tcs(dec) , $coordSystem  , $tcs(epoch)\
                       , $pma  , $pmd  , $radvel  , $parallax  , $cooType "


   # Extract epoch system

   set tcs(coordSystem) [string trim $coordSystem "{}"]
   set tcs(pma) [string trim $pma "{}"]
   set tcs(pmd) [string trim $pmd "{}"]   
   set tcs(radvel) [string trim $radvel "{}"]
   set tcs(parallax) [string trim $parallax "{}"]   
   set tcs(coordinateType) [string trim $cooType "{}"]   

   set tcs(epochSystem) [string index $tcs(coordSystem) 0]
   set tcs(equinox)     [string range $tcs(coordSystem) 1 end]
}


proc getRaDecFromRtd {} {
   global ::tcs

#   if {$tcs(starSelMode) == 2} {
#      set w .guidecam1.image.panel.info
#      set ra  [uplevel #0 set [$w.ra  cget -textvariable]]
#      set dec [uplevel #0 set [$w.dec cget -textvariable]]
#      guidecamGetStarParams  "dummy $ra $dec"
#   }
   set w .guidecam1.image.panel.info
   set ra  [uplevel #0 set [$w.ra  cget -textvariable]]
   set dec [uplevel #0 set [$w.dec cget -textvariable]]
   guidecamGetStarParams  "dummy $ra $dec"
}



proc guidecamPickObject { image w rtdTop } {
    global pickDlg
    
    if {[$image isclear]} {
	warning_dialog "No image is currently loaded" $w
	return
    }
    
    if ![winfo exists $w.pick] {
	set pickDlg [guidecamImagePick $w.pick -center 0 -target_image $image -samplesize 40 \
		-rtdTop $rtdTop -minsize 20 -maxsize 80]
    }
    utilRaiseWindow $pickDlg
    return $pickDlg
}


proc makeAgSetupFile {} {
   global env

   set ret [slxtclSaveSetup ccdAgRtdWindow.det "Detector Setup"]

   if {$ret != "OK"} {
     set msg "Failure Generating Setup File"
     tk_dialog .dialog "Dialog Box" $msg info 0 OK
      return
   }
}

proc guidecamPresetCmd {} {
   global env tcsEnvName tcsProc tcs

   if {[cequal $tcsProc ""]} { return }

   if {[cequal $tcsEnvName ""]} {
      if {[info exists env(RTAPENV)]} {
         set tcsEnvName $env(RTAPENV)
      } else {
         return
      }
   }

   # Check if all 'two-digit' and format as 'hhmmss.uu'

   set tcs(alpha) [guidecamCheckRaDec $tcs(ra)]
   set tcs(delta) [guidecamCheckRaDec $tcs(dec)]

   set parList [list alpha delta epochSystem epoch equinox pma pmd radvel \
                     parallax coordinateType ]

   # The buffer is formatted in order to be able to get the default values
   # for the 'missing' parameters.

   set buf ""
   foreach item $parList {
       if {![cequal $tcs($item) ""]} {
          append buf " -$item $tcs($item)"
       }
   }

   panSendCommand $tcsEnvName $tcsProc PRSCOOR $tcs(checkCmd) 360000 $buf
}


proc guidecamCheckRaDec { val } {

   set ret [split $val ":."]
   set len [llength $ret]
   set uu 00

   for {set i 0} {$i < $len} {incr i} { 
       set tmp [lindex $ret $i]
       if {[string length $tmp] == 1} {set tmp 0$tmp }

       switch $i {
	   0 { set hh $tmp}
           1 { set mm $tmp}
           2 { set ss $tmp}
           3 { set uu $tmp}
       }
       
   }

   return "${hh}${mm}${ss}.${uu}"
}

proc guidecamSendSetup {} {
   global env tcsEnvName agProcName seq_ccsCmdCheck

   if {[cequal $agProcName ""]} { return }

   if {[cequal $tcsEnvName ""]} {
      if {[info exists env(RTAPENV)]} {
         set tcsEnvName $env(RTAPENV)
      } else {
         return
      }
   }

   # Format the message buffer for the SETUP command

   set buf ",,[slxtclPanToBuf],FALSE,FALSE"

   panSendCommand $tcsEnvName $agProcName SETUP CHECK_ALL 10000 $buf
}


proc guidecamSendCmd { envName procName cmd buf } {
   global seq_ccsCmdCheck

   set seq_ccsCmdCheck CHECK_ALL

   if {[catch {seq_msgSendCommand $envName $procName $cmd $buf} cmdId] } {
      seq_errDisplay 
      return
   }

   # Wait for reply

   if { [catch {seq_msgRecvReply -all $cmdId errNr lr -5000 } ret] } {  
      seq_errDisplay
      return
   }
}


proc displayAgSetupFile {fileName} {
   global env

   set filePath $env(INS_ROOT)/SYSTEM/COMMON/SETUPFILES/DET/$fileName

   panExecTerm cat $filePath
}


#
# Dummy procedure to define variables used by the panel editor
# with some 'dummy' values ... just not to get complaints
# 
proc panWrapAround {} {
   global gvar cv par
   
   set par(CCS) 1
   set cv "."
   set par(ROOT_PANEL) ""
}


#
# ___oOo___
