#*************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: panSetAutoPath.tcl,v 5.19 2003/02/14 14:23:47 vltsccm Exp $"
#
# who       when        what
# --------  ----------  ----------------------------------------------
# mcomin    02/06/95    created
# mcomin    11/01/96    Added default library libuifCommon
# eallaert  1999-03-03  Avoid repeated entries in auto_path
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

#------------------------------------------------------------------------------
# PROCEDURE : panSetAutoPath - Sets auto paths to libraries
#------------------------------------------------------------------------------

proc panSetAutoPath { panUsrLib panClassLib } {
   global env auto_path INTROOT VLTROOT env panClock panDEBUG

   if {![info exists env(TCLTK_ROOT)]} {
      set env(TCLTK_ROOT) undefined
   }

   set libList [concat $panClassLib $panUsrLib libuif libuifClass libuifCommon]

   foreach libName $libList {

      if {[cequal [file extension $libName] ".tcl"] } {
         set libName [file rootname $libName]
      }

      # Check in MODROOT,INTROOT and VLTROOT

      if { [catch {seq_findFile lib/$libName.tcl } absPath] == 0} {
          if {[lsearch -exact $auto_path $absPath] == -1} {
	      lappend auto_path $absPath
	  }
      } elseif {[file exist $env(TCLTK_ROOT)/lib/$libName]} { 
          if {[lsearch -exact $auto_path $env(TCLTK_ROOT)/lib/$libName] == -1} {
	      lappend auto_path $env(TCLTK_ROOT)/lib/$libName
	  }
      } else {
          puts stderr "WARNING :  Tcl library $libName not found."
      }


   }; # end foreach ...
}

proc panCheckLibPath { libName } {
   global env auto_path INTROOT VLTROOT env panClock panDEBUG

   if {![info exists env(TCLTK_ROOT)]} {
      set env(TCLTK_ROOT) undefined
   }

   if {[cequal $libName ""]} { return "NOT_FOUND" }

   if {[cequal [file extension $libName] ".tcl"] } {
      set libName [file rootname $libName]
   }

   # Check in the current module

   if {[file exist ../lib/$libName.tcl]} {        
      set absPath [seq_relToAbsPath ../lib/$libName.tcl]
      if {[lsearch -exact $auto_path $absPath] != -1} {
	 return MODULE
      }

   } elseif {[file exist $INTROOT/lib/$libName.tcl]} {
      if {[lsearch -exact $auto_path $INTROOT/lib/$libName.tcl] != -1} {
	 return INTROOT
      }

   } elseif {[file exist $VLTROOT/lib/$libName.tcl]} { 
      if {[lsearch -exact $auto_path $VLTROOT/lib/$libName.tcl] != -1} {
	 return VLTROOT
      }

   } elseif {[file exist $env(TCLTK_ROOT)/lib/$libName]} { 
      if {[lsearch -exact $auto_path $env(TCLTK_ROOT)/lib/$libName] != -1} {
	 return TCLTK_ROOT
      }

   } elseif { [file exist $libName] } {
       if {[lsearch -exact $auto_path $libName] != -1} {
	 return NOT_VLT
       }
   } else {
       return "NOT_FOUND"
   }
}

#
# ___oOo___
