#*************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: panShowError.tcl,v 5.19 2003/02/14 14:23:49 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin    24/10/95  created
# mcomin    30/10/95  Add possibility to configure bitmap parameter
#                     Adjust size according to the text length
# mcomin    21/01/96  Fixed bug with statement 'destroy $w'
#           06/03/97  Porting to TK 4.2
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc panShowError { w text bitmap default args } {
   global errorInfo tk_priv
   
   if {[winfo exists $w]} { destroy $w }  
   
   # Estimate the width of the window  
   
   if {[set idx [string first "\n" $text]] != -1 } {
      set len $idx
   } else {
      set len [string length $text]
   }    

   if {$len > 40 } { 
      set msgWidth "40c"
   } else {
      set msgWidth  ${len}c
   }
   
   toplevel $w -class Dialog
   wm title $w "Error Dialog"
   wm iconname $w Dialog

   set top [frame $w.top -relief raised -bd 2]
   set bot [frame $w.bot -relief raised -bd 1]

   label $w.lbl1 -text "Tcl/Tk Error Stack" \
                 -font "-Adobe-helvetica-bold-r-normal--14*-iso8859-1"  

   UifText $w.stack -width 36 -height 8 \
                    -font "-Adobe-courier-medium-r-normal--12*-iso8859-1"

   pack $top     -fill both
   pack $w.lbl1  -pady 5  -fill x
   pack $w.stack -pady 3  -expand yes -fill x
   pack $bot     -expand yes -fill x

   $w.stack insertText 0.0 $errorInfo
   
   #
   # Fill the top part with bitmap and message.
   #

   message $w.msg -width $msgWidth  -text $text \
           -font "-Adobe-courier-medium-r-normal--12*-iso8859-1"

   pack $w.msg -in $top -side right -expand 1 -fill both -padx 5m -pady 5m
   
   if {![cequal $bitmap ""]} {
      label $w.bitmap -bitmap $bitmap
      pack $w.bitmap -in $top -side left -padx 5m -pady 5m
   }

   #
   # Create a row of buttons at the bottom of the dialog.
   #
   button $w.seeStack -text "Show CCS Error" -command seq_errDisplay -width 12
   pack $w.seeStack -in $bot -side left -expand yes -padx 3m -pady 3m -ipadx 2m -ipady 1m

   set i 0
   foreach but $args {
	button $w.button$i -text $but -command "set tk_priv(button) $i"
	if {$i == $default} {
	    frame $w.default -relief sunken -bd 1
	    raise $w.button$i $w.default
	    pack $w.default -in $bot -side left -expand 1 -padx 3m -pady 2m
	    pack $w.button$i -in $w.default -padx 2m -pady 2m \
		    -ipadx 2m -ipady 1m
	    bind $w <Return> "$w.button$i flash; set tk_priv(button) $i"
	} else {
	    pack $w.button$i -in $bot -side left -expand 1 \
		    -padx 3m -pady 3m -ipadx 2m -ipady 1m
	}
	incr i
   }

   update idletasks

   wm resizable $w 1 0 ;# Allow the user to re-size only along X
      
   #
   # Wait for the user to respond, then restore the focus and
   # return the index of the selected button.
   #

   vwait tk_priv(button)
   destroy $w
   return $tk_priv(button)
}
#
# ___oOo___
