#************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: panTerm.tcl,v 5.19 2003/02/14 14:23:42 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin  15/05/96  created
#

#************************************************************************
#   NAME
#
#   SYNOPSIS
#
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc panTerm { title buffer} {

   global panTermReturn

   set top    .panTerm;  # Define the outer most part of the panel
   set c      $top.top;  # Define 'Virtual Root'
   set myText $c.txt; 

   # If the window already exist , just update the contents

   if {[winfo exists $top]} {   
     $myText deleteText 0.0 end
     $myText insertText 0.0 $buffer
     wm title $top $title
     return
   }

   toplevel $top
   frame $c ; pack  $c 

   #################################      
   #     Creation of Menu Bar   
   #################################
   
   set menuBar  [ makeMenuFrame $c]

   #  File Menu

   set mbFile [addMenu $menuBar  File  1]; 
   addMenuCmd $mbFile "Print On Screen"  0  "panTermPrint $myText"
   addMenuCmd $mbFile "Quit"             0  "panTermQuit $top"

   #  "Help" Menu
    
   set mbHelp [addMenu $menuBar  Help  1 right];      # Help Menu
   addMenuCmd $mbHelp "Extended Help"  0  {puts "Not Implemented"}  

   #################################      
   #     Creation of panel
   #################################

   frame $c.f1

   UifText $myText -width 80 -height 24 \
           -font -Adobe-courier-medium-r-normal--12*-iso8859-1
   
   pack $c.f1 -pady 10 -fill x
   pack $myText -padx 5 -pady 5
   
   $myText insertText 0.0 $buffer 
   
   wm title $top $title
   set tmp [wm protocol $top WM_DELETE_WINDOW]
   wm protocol $top WM_DELETE_WINDOW "$tmp ; panTermQuit $root"
}

proc panTermPrint { w } {
   puts "[$w getText 0.0 end]"
   flush stdout
}

proc panTermQuit { w } {
   global panTermReturn
   set panTermReturn ""
   destroy $w
}





#
# ___oOo___
