#**************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: setPublicVar.tcl,v 5.19 2003/02/14 14:23:40 vltsccm Exp $" 
#
# who       when      what
# --------  --------  ----------------------------------------------
# M.Bernini 24/05/94  created 
# M.Comin   05/07/94  Store it into a separate file .. with comments
#                     Contains only variables needed by both panels
#                     and panel editor
# M.Comin   27/07/94  Add names for frames in the working window
# M.Comin   28/09/94  add definition for database interface
# ------------------
# M.COMIN   13/02/95  Cleaned widget data structure
# M.COMIN   08/03 95  Add db_log field in panDbData()
# M.COMIN   21/03/95  Add i_list for UifListBox
# mcomin    25/10/95  Add i_subClass flag
#
#************************************************************************
#   NAME
#
#   setPublicVar - Initialize 'Public' variables
# 
#   SYNOPSIS
#
#   setPublicVar
# 
#   DESCRIPTION
#
#   FILES
#    
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#------------------------------------------------------------------------
#

proc setPublicVar {} {

   if {[uplevel #0 info exists setPublicVarDone]} { return }

   uplevel #0 set setPublicVarDone 1

   global panWidgetHlp panRtapEnv  panWidget panDbData
   global panUsrProcs  panUsrLib   flagDialog panSubList
   global host env par gvar orig_tcl_precision tcl_precision

   global i_type      i_posX    i_posY      i_status  i_dbVar 
   global i_dbOff     i_ckType  i_ckRange   i_text    i_outFormat
   global i_dataType  i_dbOn    i_min       i_max     i_bitmap
   global i_dbMin     i_dbMax   i_on        i_off     i_default 
   global i_subClass  i_var     i_stateVar            i_precision
   global i_clib      i_list    i_clAnchor  i_font    i_reSize
   global i_classFrame
   
   global m_label  m_uline m_name m_help

   # Here ... for backward compatibility
   global m_type  m_parent  m_sub  m_cmd  m_var  m_val
 
   global db_var   db_onval db_offval db_min  db_max   db_env 
   global db_type db_def   db_log    db_poll db_event
  
   # Special global variables

   global pollRate cwp cwpEnv localEnv seqFlag panDEBUG panActiveEnv

   # Initialization of special global variables

#   set panActiveEnv(LOCAL) 1
   set panDEBUG dbgNONE
   if {[info exists tcl_precision] == 0} { set tcl_precision 6 }
   set orig_tcl_precision $tcl_precision
   set pollRate 3000;

   set gvar(none)       {none};  # Array containing the widget variables
   set panWidget(none)  {none};  # Widget description
   set panDbData(none)  {0 0 0 0 0 0 0 0 0 0 0 0};  # DB interface Description
       
   #
   # Set Default Values
   #

   set par(POPUP_POSX)  200  ;# Starting X coord. on the screen
   set par(POPUP_POSY)  100  ;# Starting Y coord. on the screen

   set par(NUMBER)        N  ;# Value for 'N' Number DataType
   set par(ASCII)         A  ;# Value for 'A' ASCII  DataType
   set par(ENV_LIST)     {}
   set par(MYCLASS)      ""

   if {[info exists par(TITLE)] == 0 } { set par(TITLE) "Dummy" }

   #
   # Set indexes to access widget configuration data structure
   #

   set i_type       0; # Widget Type
   set i_posX       1; # Widget X coord
   set i_posY       2; # Widget Y coord
   set i_status     3; # Widget Initial status : normal or disabled
   set i_dbVar      4; # Indicate reference to DB for parm. variable

   set i_default    5;   
   set i_clib       5; # Class library
   
#   set i_dbDef      6;
   set i_clAnchor   6; # Class anchoring point
      
#   set i_clName     7; # Identifies the widget as belonging to a class
#                       # In this case no editing from a normal panel
#                       # is allowed                        
                   
   set i_subClass   7; # Flags the widget as class component. 
           
   set i_var        8; # Widget variable                          

   set i_dummy      9; # Free
   set i_classFrame 9; # Free
               
   set i_bitmap     10; # Bitmap file name 
##   set i_list       10; # Current list
   set i_off        10; # Actual OFF value
   set i_outFormat  10; # Output format description
   set i_dataType   10; # Type of data for entry : ASCII or NUMBER
   set i_text       10; # Text for 'freeText' widgets 
   set i_reSize     10; # Sets automatic re-sizing for frames

   set i_precision  11; # Precision specification for real numbers
   set i_on         11; # Actual ON value
   set i_min        11; # Range : Min Value
  
   set i_font       12; # Text Widget Font
   set i_max        12; # Range : Max Value

   set i_dbOff     13; # Indicate reference to DB for param. OFF value
   set i_dbMin     13; # Indicate reference to DB for param. MIN value

   set i_dbOn      14; # Indicate reference to DB for param. ON value
   set i_dbMax     14; # Indicate reference to DB for param. MAX value

   set i_ckType    15; # Enable dataType checking
   
   set i_ckRange   16; # Enable Range    checking

   #
   # Set indexes to access database interface data structure
   #

   set db_type      0; # Determine the type of UIF widget
   set db_env       1; # Environment Name
   set db_var       2; # Variable symbolic adddress
   set db_def       3; # variable with default value
   set db_onval     4; # ON  value : symbolic adddress 
   set db_offval    5; # OFF value : symbolic adddress
   set db_min       6; # MIN value : symbolic adddress
   set db_max       7; # MAX value : symbolic adddress
   set db_log       8; # Flag to log an error condition
   set db_poll      9; # Flag to enable polling
   set db_event    10; # Database event handle

   #
   # Set indexes to access MenuBar Configuration data structure
   #

   set m_label  0 
   set m_uline  1
   set m_name   2
   set m_help   3
 
   # Here for backward compatibility

   set m_parent 2 ; set m_type  2 ; set m_type  2 ;   
   set m_cmd    3 ; set m_sub   3;
   set m_var    4
   set m_val    5

   set host [file tail [info script]]
}

