#******************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: findModuleFile.tcl,v 3.36 2003/01/20 10:33:42 vltsccm Exp $" 
#
# findModuleFile.tcl
#
# who       when      what
# --------  --------  ----------------------------------------------
# G.Filippi 23/06/94  created
#

#************************************************************************
#   NAME
#
#   findModuleFile - locate a file in MODROOT.
# 
#   SYNOPSIS
#        findModuleFile <[relativePath]/file>
#
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#------------------------------------------------------------------------
#

proc findModuleFile { file } {
   
    upvar #0 env env ;      # To access the environment variables
      
    #
    # Take the only file name and check in the current directory
    #

    set myFile   [exec basename  $file]   
    set fileName [pwd]/$myFile

    if {[file exist $fileName] == 1} { return  $fileName }

    #
    # Does the file exist in the current sub-directory?
    #
    
    set fileName [pwd]/$file
    if {[file exist $fileName] == 1} { return  $fileName }
  
    #
    # Does the file exist in the current module?
    # (the current module is assumed to be the parent directory 
    #  of the current pwd)
    
    set fileName ../$file
    if {[file exist $fileName] == 1} { return  $fileName }
         
    #
    # File does not exist. Exit with error:
    #
   
    return "";
}

# ___oOo___ 
