#**************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: uifFrame.tcl,v 3.36 2003/01/20 10:33:52 vltsccm Exp $" 
#
# uifFrame.tcl
#
# who         when      what
# --------   --------   ----------------------------------------------
# M.COMIN    17/03/94   created 
# M.COMIN    31/07/95   Use args instead of config
# -------------------
# mcomin     09/03/96   Ported to Tk4.0 and itcl 2.0
#            13/05/96   Update man page
#
#************************************************************************
#   NAME
#     UifFrame - Class for VLT frame
#   SYNOPSIS
#     UifFrame  <widget-name>
#   DESCRIPTION
#     UifFrame defines the class for the VLT frame widget.
#
#   COMPONENTS
#     The itk 'component' method returns the component's full name.
#
#     uifFrame - frame widget.
#   METHODS
#
#   PUBLIC VARIABLES
#
#   WIDGET OPTIONS
#
#     Inherits options from UifWidget classe and supports 
#     the followings :
#
#     height  <integer>     Determine the height of the widget
#     width   <integer>     Determine the widget length
#
#   SPECIFIC BINDINGS
#
#   CAUTIONS
#
#   EXAMPLES
#
#     Create an instance
#
#     UifFrame .w  -width 200 -height 20 
#
#     Re-configure the widget
#        .w  configure -width 150
#
#     Other operations
#        set width  [.w cget -width]   Get a widget's resource
#
#   SEE ALSO
#     UifWidget
#   BUGS
#
#------------------------------------------------------------------------
#

itk::usual UifFrame { }

class UifFrame {
    inherit  UifWidget
    constructor {args} {}
}; # end of class


#------------------------------------------------------
# Constructor
#------------------------------------------------------

body UifFrame::constructor {args} {

   itk_component add uifFrame  {
      frame $itk_interior.uifFrame -relief groove -borderwidth 2
   } { 
      keep -width -height -background
   }

   pack $itk_component(uifFrame) -fill both -expand 1
   eval itk_initialize
   eval configure -width 100 -height 50 $args
}
