#*************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: uifMisc.tcl,v 3.36 2003/01/20 10:33:57 vltsccm Exp $"
#
# who       when      what
# --------  --------  ----------------------------------------------
# mcomin  10/09/96  created
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

proc uifAddToDataList { w var } {
   global panDataToWidget

   if {[cequal [$w cget -dbMode] "none"]} { return }

   # Check if the variable can be an Rtap DB Attribute
   # for example   a:b.c(1:2,3:4)

   if {[string first ":" $var ] < 0 && [string first "." $var] < 0 } {
      return 
   }

#   puts "DBG> uifAddToDataList $w $var"

   if {[info exist panDataToWidget($var)]} {
      if {[lsearch $panDataToWidget($var) $w] != -1} { return }
   } else {
      lappend panDataToWidget($var) 0
   }

   lappend panDataToWidget($var) $w
#      puts "DBG> addToDataList $var  > $panDataToWidget($var)"
}

#
# panDataToWidget contains all widgets linked with a given DB value.
# Its structure is :
#
# panDataToWidget(name) = flag  widget1 widget2  ...
#
# The parameter 'flag' is used to control the quality on the screen.
#

proc uifUnsetData { w rec var } {
   global panDbData panWidget panWidgetHlp panDbSymbAddr panDataToWidget

#   puts "DBG> uifUnsetData ... rec = ($rec)  var = ($var)"

   catch {unset panDbSymbAddr($rec) panWidget($rec) panDbData($rec)\
                   panWidgetHlp($rec) }

   if {![cequal $var ""] && [info exists panDataToWidget($var)]} {
      if {[llength $panDataToWidget($var)] < 3} {
#         puts "DBG> unset panDataToWidget($var)  for $w"
         unset panDataToWidget($var)
      } else {
         set idx [lsearch $panDataToWidget($var) $w]
#         puts "DBG> lreplace panDataToWidget idx = $idx  for $w"
         set panDataToWidget($var) [lreplace $panDataToWidget($var) $idx $idx]
      }
   }
}

#------------------------------------------------------------------------------
# PROCEDURE : uifGetInput -  Check for empty input : the procedure return 
#                            the user input data or an empty string if the 
#                            entry widget is empty
#------------------------------------------------------------------------------

proc getInput { w } {
   set ret [string trim [$w get ] " "];   # Get content of the entry widget
   if { [string length $ret] == 0 } { return ""  }
   return $ret 
}

#-----------------------------------------------------------
#   Procedure   getRelPath
#
#  The procedure return the relative path of the sub-directory
#
#  Return  Offset String
#
#-----------------------------------------------------------


proc getRelPath { module  subDir } {
   set lastDir [exec basename [pwd]]
   if { $lastDir == $module } { return "./$subDir" } 
   if { $lastDir == $subDir } { return "." }
   return "../$subDir"
} 

#
# ___oOo___
