#*************************************************************************
# E.S.O. - VLT project
#
# "@(#) $Id: uifWaitDialog.tcl,v 3.36 2003/01/20 10:34:00 vltsccm Exp $"
#
# who       when        what
# --------  ----------  ----------------------------------------------
# mcomin    03/12/96    created
#           20/08/98    Fixed bug in updatePercentage
# eallaert  1999-02-15  Ported to Tcl/Tk 8.0 and itcl 3.0
#

#************************************************************************
#   NAME
# 
#   SYNOPSIS
# 
#   DESCRIPTION
#
#   FILES
#
#   ENVIRONMENT
#
#   RETURN VALUES
#
#   CAUTIONS
#
#   EXAMPLES
#
#   SEE ALSO
#
#   BUGS     
#
#------------------------------------------------------------------------
#

itk::usual UifWaitDialog {}

class UifWaitDialog {
    inherit itk::Toplevel

    constructor {args} {}

    itk_option define -title    title    Title    "Waiting Dialog"
    itk_option define -step     step     Step     5
    itk_option define -refValue refValue RefValue 100

    public method updatePercentage {val}

    private variable wthis ""
    private variable finalValue 0
}
    
#------------------------------------------------------
# Constructor
#------------------------------------------------------

body UifWaitDialog::constructor { args } {
    global tcl_version
    set wthis [namespace tail $this]

   itk_component add what {
      label $itk_interior.what -anchor w \
            -font -Adobe-helvetica-bold-r-normal--14*
   } {
      keep -text
   }

   itk_component add meter {
       UifBarChart $itk_interior.meter -axis 1 -ticks 1
   } {
     keep -length -axis
   }  

   eval itk_initialize

   pack $itk_component(what) $itk_component(meter) -fill x \
        -anchor w -pady 5

   wm withdraw   $itk_component(hull)
   wm group      $itk_component(hull) .
   wm resizable  $itk_component(hull) 0 0

   # Set default values

   configure -title "Waiting Dialog" -text "Waiting to complete" \
             -length 200

   if {[llength $args] != 0 } { eval configure $args }

   wm deiconify  $itk_component(hull)
   $itk_component(meter) setValue 0.0
   update
}

#---------------------------------------------------------------
# METHOD : updatePercentage
#---------------------------------------------------------------

body UifWaitDialog::updatePercentage { val } {
   set percent [expr {(double($val)/double($itk_option(-refValue))) * 100 } ]
   $itk_component(meter) setValue [expr {round($percent)} ]
}

#---------------------------------------------------------------
# OPTION : -title
#---------------------------------------------------------------  

configbody UifWaitDialog::title {
   wm title  $itk_component(hull) $itk_option(-title)
}

#
# ___oOo___



